﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class HUD : MonoBehaviour {

    public Image currentLaserType;
    public Text currentLaserName;
    public GameObject notificationPanel;
    public Text notificationText;

    public GameObject hpBar;
    public Image hpFill;
    public float hpDisplayDuration = 3f;

    private void Awake()
    {
        notificationPanel.SetActive(false);
    }

    public void SetCurrentLaserText(ProjectileType projectileType)
    {
        switch (projectileType)
        {
            case ProjectileType.damaging:
                currentLaserName.text = "Lethal";
                break;


            case ProjectileType.platformMaker:
                currentLaserName.text = "Platform Maker";
                break;


            case ProjectileType.platformBreaker:
                currentLaserName.text = "Platform Breaker";
                break;

            case ProjectileType.data:
                currentLaserName.text = "Data";
                break;


            default:
                currentLaserName.text = "default";
                break;

        }
        
    }


    public void SetLaserDisplay(Color colour)
    {
        currentLaserType.color = colour;
    }

    public void DisplayNotification(string text)
    {
        notificationText.text = text;
        notificationPanel.SetActive(true);
    }

    public void DisplayHP()
    {
        hpFill.fillAmount = Player.instance.hitPoints / 3.0f;

        StartCoroutine(ShowHP());
    }

    IEnumerator ShowHP()
    {
        hpBar.SetActive(true);

        float timer = Time.time + hpDisplayDuration;
        while(timer > Time.time)
        {
            yield return null;
        }

        hpBar.SetActive(false);
        yield return null;
    }
}
