﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Destroyable : MonoBehaviour {

    public bool hasHP = false;
    public int hitPoints = 0;
    public ParticleSystem particleSystem;
    public SpriteRenderer spriteRenderer;

    private void OnEnable()
    {
        spriteRenderer.enabled = true;
    }

    void OnCollisionEnter2D(Collision2D collision)
    {
        if (collision.collider.GetComponent<Projectile>() != null)
        {
            Projectile p = collision.collider.GetComponent<Projectile>();
            if (p.projectileType != ProjectileType.damaging)
            {
                return;
            }

            if (hasHP == false)
            {
                Destroyed();
            }
            else
            {
                hitPoints -= p.damage;
                if (hitPoints <= 0)
                    Destroyed();
            }
        }
    }

    void Destroyed()
    {
        if (particleSystem != null)
        {
            StartCoroutine(deactivateAfterParticleEffect());
        }
        else
        {
            gameObject.SetActive(false);
        }
    }

    IEnumerator deactivateAfterParticleEffect()
    {
        spriteRenderer.enabled = false;
        particleSystem.Play();

        while(particleSystem.isPlaying)
        {
            yield return null;
        }

        gameObject.SetActive(false);
        yield return null;
    }
}
