﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class EnemyProjectile : MonoBehaviour {

    public float speed = 3f;
    public int damage = 1;
    public float life = 5f;
    public SpriteRenderer spriteRenderer;
    public Rigidbody2D rb;

    public void Fire(Vector3 direction)
    {
        rb.AddForce(direction * speed, ForceMode2D.Impulse);
        StartCoroutine(lifeTimer());
    }

    private void Disable()
    {
        rb.velocity = Vector2.zero;
        gameObject.SetActive(false);
    }

    IEnumerator lifeTimer()
    {
        float start = Time.time;
        while (Time.time - start < life)
        {
            yield return null;
        }

        Disable();
        yield return null;
    }

    private void OnCollisionEnter2D(Collision2D collision)
    {
        if(collision.gameObject.CompareTag("Player"))
        {
            Player.instance.TakeDamage(damage);
        }

        Disable();
    }
}
