﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class HazaardSpawner : MonoBehaviour {

    public bool randomSpawnOffset = false;
    public Vector3 offsetRange = new Vector3(1, 1, 0);
    public float rate = 3f;
    public Transform startPosition;
    public ObjectPool objectPool;

    private WaitForSeconds waitTime;
    
	void Start () {
        waitTime = new WaitForSeconds(rate);

        if (randomSpawnOffset == false)
        {
            StartCoroutine(Spawn());
        } else
        {
            StartCoroutine(SpawnRandomOffset());
        }
	}

    IEnumerator Spawn()
    {
        while(true)
        {
            objectPool.ActivateObject(startPosition.position);

            yield return waitTime;
        }
    }

    IEnumerator SpawnRandomOffset()
    {
        Vector3 randomOffset;
        while (true)
        {
            randomOffset = new Vector3(Random.Range(-offsetRange.x, offsetRange.x), Random.Range(-offsetRange.y, offsetRange.y), 0);
            objectPool.ActivateObject(startPosition.position + randomOffset);

            yield return waitTime;
        }
    }
}
