﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Turret : MonoBehaviour {

    private bool turretOnline = false;
    private bool firing = false;

    public float fireDelay = 1;
    private WaitForSeconds delay;

    public Transform barrel;
    public Transform gun;
    public ObjectPool laserPool;

    private void Awake()
    {
        delay = new WaitForSeconds(fireDelay);
    }

    void Update()
    {
        if (turretOnline == true)
        {
            gun.right = (gun.position - Player.instance.transform.position);
        }

        if (barrel.parent.gameObject.activeSelf == false)
        {
            StopCoroutine(Fire());
            gameObject.SetActive(false);
        }
    }

    private void OnTriggerEnter2D(Collider2D collision)
    {
        if(collision.CompareTag("Player") && turretOnline == false)
        {
            turretOnline = true;
            Activate();
        }
    }

    private void OnTriggerExit2D(Collider2D collision)
    {
        if(collision.CompareTag("Player") && turretOnline == true)
        {
            turretOnline = false;
            Deactivate();
        }
    }

    private void Activate()
    {
        if (firing == false)
        {
            firing = true;
            StartCoroutine(Fire());
        }
    }

    private void Deactivate()
    {
        StopCoroutine(Fire());
        firing = false;
    }

    IEnumerator Fire()
    {
        float timer = Time.time + fireDelay;
        while(turretOnline == true)
        {
            while(timer > Time.time)
            {
                yield return null;
            }

            Debug.Log("firing");
            GameObject laser = laserPool.ActivateObject(barrel.position);
            laser.GetComponent<EnemyProjectile>().Fire(-gun.right);

            timer = Time.time + fireDelay;

            yield return null;
        }

        yield return null;
    }



}
