﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(Rigidbody2D))]
[RequireComponent(typeof(BoxCollider2D))]
public class NodeConnectionRay : MonoBehaviour {
    
    public float speed = 3;
    public Rigidbody2D rb;
    private ShootableNode node;
    private ShootableNode targetNode;
    private Vector3 direction;

    public void TryConnection(ShootableNode node, ShootableNode targetNode, Vector3 direction)
    {
        rb.AddForce(direction.normalized * speed, ForceMode2D.Impulse);
        this.node = node;
        this.direction = direction;
        this.targetNode = targetNode;
    }

    private void OnTriggerEnter2D(Collider2D collision)
    {
        if(targetNode != null && collision.gameObject == targetNode.gameObject)
        {
            if (Player.instance.selectedNode != null)
                Player.instance.selectedNode = null;

            node.MakeBridgeConnection(direction, targetNode);
            gameObject.SetActive(false);
        }
    }

    private void OnCollisionEnter2D(Collision2D collision)
    {
        if(node != null)
            node.inUse = false;

        if (targetNode != null)
            targetNode.inUse = false;

        if (Player.instance.selectedNode != null)
            Player.instance.selectedNode = null;

        gameObject.SetActive(false);
    }

}
