﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ObjectPool : MonoBehaviour {
    
    public int poolSize = 10;
    public GameObject objectPrefab;
    public List<GameObject> objects = new List<GameObject>();
    public bool canGrow = false;

    void Start()
    {
        for (int i = 0; i <= poolSize; i++)
        {
            objects.Add(Instantiate(objectPrefab));
            objects[i].gameObject.transform.SetParent(transform);
            objects[i].gameObject.SetActive(false);
        }
    }

    public GameObject ActivateObject(Vector3 position)
    {
        GameObject go = getInactive();

        if (go == null)
            return null;

        go.gameObject.SetActive(true);
        go.transform.position = position;

        return go;
    }

    private GameObject getInactive()
    {
        GameObject go = null;

        foreach (GameObject g in objects)
        {
            if (g.gameObject.activeSelf == false)
            {
                go = g;
                break;
            }
        }

        if (go == null && canGrow == true)
        {
            go = IncreasePool();
        }
        else if (go == null)
        {
            return null;
        }

        return go;
    }

    public GameObject IncreasePool()
    {
        objects.Add(Instantiate(objectPrefab));
        objects[objects.Count - 1].transform.SetParent(transform);
        return objects[objects.Count - 1];
    }
}
