﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class AAPM : MonoBehaviour {

    public AnimateSprite animateSprite;
    public Rigidbody2D rb;
	
	[SerializeField]
	private float speed = 15f;
	
	[SerializeField]
	private float jumpForce = 15f;
	
	private float horizontal;
	
	[SerializeField]
	private Transform[] groundPoints;
	
	[SerializeField]
	private float groundRadius;
    public float groundDistance = 0.01f;
	
	[SerializeField]
	private LayerMask whatIsGround;
	
	private bool isGrounded;
	
	private bool jump;
	
	// Use this for initialization
	void Start () {
		rb = GetComponent<Rigidbody2D>();
	}
	
	// Update is called once per frame
	void FixedUpdate () {
		horizontal = Input.GetAxis("Horizontal");
		
		isGrounded = IsGrounded();
		
		HandleMovement(horizontal);
        if(horizontal == 0)
        {
            animateSprite.Idle();
        } else if(horizontal != 0)
        {
            animateSprite.Move();

            if (horizontal < 0)
            {
                animateSprite.transform.localScale = animateSprite.spriteScaleLeft;
                Player.instance.gunArm.flipY = true;
                Player.instance.boxCollider2D.offset = Player.instance.leftFacingBoxOffset;
                Player.instance.arm.localPosition = Player.instance.shoulderMountLeft;

            } else if (horizontal > 0)
            {
                animateSprite.transform.localScale = animateSprite.spriteScaleRight;
                Player.instance.gunArm.flipY = false;
                Player.instance.boxCollider2D.offset = Player.instance.rightFacingBoxOffset;
                Player.instance.arm.localPosition = Player.instance.shoulderMountRight;
            }
        }
		
		if(Input.GetKey("w") && isGrounded == true){
			jump = true;

		}
		
	}
	
	private void HandleMovement(float horizontal){
		rb.velocity = new Vector2(horizontal * speed, rb.velocity.y);
		
		if(isGrounded && jump){
			isGrounded = false;
			rb.AddForce(new Vector2(0, jumpForce));
			jump = false;
		}
	}
	
	private bool IsGrounded(){
		if(rb.velocity.y <= 0){
            bool grounded = false;
			foreach(Transform point in groundPoints){
                RaycastHit2D hit = Physics2D.Raycast(point.position, Vector2.down, groundDistance, whatIsGround);

                if (hit.collider != null)
                    grounded = true;
			}

            return grounded;
		}
		return false;
	}
	
	
}
